from .qubopt_common import *

qo.mpltreeiface.argtypes = (PNode, POINTER(PNode), QTR_Callback, QTR_Callback, QTR_Callback, QTR_Callback)
qo.mpltreeiface.restype = PNode

def MPL(config, source_segs, on_report=lambda s: None, on_result=lambda result: None, on_percent=lambda pct: None, **kw):
    cfg = prep_tree(config)
    for k, v in kw.iteritems():
        cfg[k].data = v
    dat = [source_to_dataset(source_segs)]
    def fill_data(seg):
        src = source_segs[0].clone()
        src.f, src.l = seg.data[:2]
        seg['Channels'].data = src.get_samples().samples.flat.astype('float64')
        return seg
    ptr_array = (PNode * 1)()
    ptr_array[0] = d.impl
    ptr_array[1] = None
    result_impl = qo.mpltreeiface(cfg.impl, ptr_array, wrap_callback(fill_data), wrap_callback(on_report), wrap_callback(on_result), wrap_callback(on_percent))
    result = qubx.tree_native.Node(impl=result_impl)
    qubx.tree_native.qubtree.QTR_DECREF(result_impl)
    return result

def get_mpl_config():
    config = qubx.tree_native.Node('Properties')
    config.append( prep_tree(QubX.Models.file.as_tree()) )
    return config
